unit IAChartBaseLinesEditUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls;

type
  TIAChartBaseLinesEditWindow = class(TForm)
    PageControl1: TPageControl;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Label1: TLabel;
    Button4: TButton;
    Panel1: TPanel;
    Label2: TLabel;
    Button5: TButton;
    Panel2: TPanel;
    Label3: TLabel;
    Button6: TButton;
    Panel3: TPanel;
    Label4: TLabel;
    Button7: TButton;
    Panel4: TPanel;
    Button8: TButton;
    Bevel1: TBevel;
    Button9: TButton;
    Label5: TLabel;
    ColorDialog1: TColorDialog;
    Button10: TButton;
    Panel5: TPanel;
    Bevel2: TBevel;
    Label6: TLabel;
    ComboBox1: TComboBox;
    Bevel3: TBevel;
    Label7: TLabel;
    Label8: TLabel;
    ComboBox2: TComboBox;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    ComboBox3: TComboBox;
    ComboBox4: TComboBox;
    ComboBox5: TComboBox;
    Button11: TButton;
    Button12: TButton;
    Panel6: TPanel;
    Panel7: TPanel;
    Button13: TButton;
    Panel8: TPanel;
    Bevel4: TBevel;
    Bevel5: TBevel;
    Bevel6: TBevel;
    ComboBox6: TComboBox;
    ComboBox7: TComboBox;
    ComboBox8: TComboBox;
    ComboBox9: TComboBox;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Bevel7: TBevel;
    Label16: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Label17: TLabel;
    Bevel8: TBevel;
    Label18: TLabel;
    Edit3: TEdit;
    ComboBox10: TComboBox;
    Label19: TLabel;
    procedure FormActivate(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Edit2Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Edit3Change(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure Button12Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure Button13Click(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure ComboBox6Click(Sender: TObject);
    procedure ComboBox7Click(Sender: TObject);
    procedure ComboBox8Click(Sender: TObject);
    procedure ComboBox9Click(Sender: TObject);
    procedure ComboBox4Click(Sender: TObject);
    procedure ComboBox5Click(Sender: TObject);
    procedure ComboBox2Click(Sender: TObject);
    procedure ComboBox3Click(Sender: TObject);
    procedure ComboBox10Click(Sender: TObject);
  private
    { Private declarations }
    NLine : integer;
    procedure GoDataFromArray;
    procedure RefreshData(ANLine : integer);
    procedure BackRefreshData;
  public
    { Public declarations }
    FCurrControl : TControl;
    procedure BackUpdate;
  end;

var
  IAChartBaseLinesEditWindow: TIAChartBaseLinesEditWindow;

implementation
uses IAChartBaseLinesUnit;
var myarray : IAChartBaseLineArray;

{$R *.DFM}

{ TIAChartBaseLinesEditWindow }

procedure TIAChartBaseLinesEditWindow.BackUpdate;
begin
  if assigned(FCurrControl) and (FCurrControl is IAChartBaseLinesClass) then
    begin
      (FCurrControl as IAChartBaseLinesClass).ColorGridBorder:=Panel1.color;
      (FCurrControl as IAChartBaseLinesClass).ColorGridX:=Panel2.color;
      (FCurrControl as IAChartBaseLinesClass).ColorGridY:=Panel3.color;
      (FCurrControl as IAChartBaseLinesClass).ColorGridY2:=Panel4.color;
      (FCurrControl as IAChartBaseLinesClass).Color:=Panel5.color;
      if Button8.Caption='Hide' then (FCurrControl as IAChartBaseLinesClass).ShowGrid:=True
                                else (FCurrControl as IAChartBaseLinesClass).ShowGrid:=False;  
      if Button9.Caption='Set Transparent' then (FCurrControl as IAChartBaseLinesClass).Transparence:=False
                                           else (FCurrControl as IAChartBaseLinesClass).Transparence:=True;
      (FCurrControl as IAChartBaseLinesClass).MainDataArray.Assign(myarray);
    end;
end;

procedure TIAChartBaseLinesEditWindow.FormActivate(Sender: TObject);
begin
  if assigned(FCurrControl) and (FCurrControl is IAChartBaseLinesClass) then
    begin
      if (FCurrControl as IAChartBaseLinesClass).LastDoubleClickedPointLineNumber<0 then
        begin//Too far to edit lines
          PageControl1.activepage:=TabSheet1;
          Panel1.color:=(FCurrControl as IAChartBaseLinesClass).ColorGridBorder;
          Panel2.color:=(FCurrControl as IAChartBaseLinesClass).ColorGridX;
          Panel3.color:=(FCurrControl as IAChartBaseLinesClass).ColorGridY;
          Panel4.color:=(FCurrControl as IAChartBaseLinesClass).ColorGridY2;
          Panel5.color:=(FCurrControl as IAChartBaseLinesClass).Color;
          if (FCurrControl as IAChartBaseLinesClass).ShowGrid then
            begin
              Button8.Caption:='Hide';
            end else
            begin
              Button8.Caption:='Show';
            end;
          if (FCurrControl as IAChartBaseLinesClass).Transparence then
            begin
              Button9.Caption:='Set Opaque';
            end else
            begin
              Button9.Caption:='Set Transparent';
            end;
          myarray.Assign((FCurrControl as IAChartBaseLinesClass).MainDataArray);
          GoDataFromArray;
          Combobox1.Text:=Combobox1.Items[0];
          ComboBox1Change(Combobox1);
        end else
        begin
          PageControl1.activepage:=TabSheet2;
          Panel1.color:=(FCurrControl as IAChartBaseLinesClass).ColorGridBorder;
          Panel2.color:=(FCurrControl as IAChartBaseLinesClass).ColorGridX;
          Panel3.color:=(FCurrControl as IAChartBaseLinesClass).ColorGridY;
          Panel4.color:=(FCurrControl as IAChartBaseLinesClass).ColorGridY2;
          Panel5.color:=(FCurrControl as IAChartBaseLinesClass).Color;
          if (FCurrControl as IAChartBaseLinesClass).ShowGrid then
            begin
              Button8.Caption:='Hide';
            end else
            begin
              Button8.Caption:='Show';
            end;
          if (FCurrControl as IAChartBaseLinesClass).Transparence then
            begin
              Button9.Caption:='Set Opaque';
            end else
            begin
              Button9.Caption:='Set Transparent';
            end;
          myarray.Assign((FCurrControl as IAChartBaseLinesClass).MainDataArray);
          GoDataFromArray;
          Combobox1.Text:=Combobox1.Items[(FCurrControl as IAChartBaseLinesClass).LastDoubleClickedPointLineNumber+1];
          ComboBox1Change(Combobox1);
        end;
    end;
end;

procedure TIAChartBaseLinesEditWindow.Button8Click(Sender: TObject);
begin
  if Button8.Caption='Hide' then
    begin
      Button8.Caption:='Show';
    end else
    begin
      Button8.Caption:='Hide';
    end;
end;

procedure TIAChartBaseLinesEditWindow.Button4Click(Sender: TObject);
begin
  ColorDialog1.Color:=Panel1.Color;
  if ColorDialog1.Execute then
    begin
      Panel1.Color:=ColorDialog1.Color;
    end;
end;

procedure TIAChartBaseLinesEditWindow.Button5Click(Sender: TObject);
begin
  ColorDialog1.Color:=Panel2.Color;
  if ColorDialog1.Execute then
    begin
      Panel2.Color:=ColorDialog1.Color;
    end;
end;

procedure TIAChartBaseLinesEditWindow.Button6Click(Sender: TObject);
begin
  ColorDialog1.Color:=Panel3.Color;
  if ColorDialog1.Execute then
    begin
      Panel3.Color:=ColorDialog1.Color;
    end;
end;

procedure TIAChartBaseLinesEditWindow.Button7Click(Sender: TObject);
begin
  ColorDialog1.Color:=Panel4.Color;
  if ColorDialog1.Execute then
    begin
      Panel4.Color:=ColorDialog1.Color;
    end;
end;

procedure TIAChartBaseLinesEditWindow.Button9Click(Sender: TObject);
begin
    if Button9.Caption='Set Transparent' then
    begin
      Button9.Caption:='Set Opaque';
    end else
    begin
      Button9.Caption:='Set Transparent';
    end;
end;

procedure TIAChartBaseLinesEditWindow.Button10Click(Sender: TObject);
begin
  ColorDialog1.Color:=Panel5.Color;
  if ColorDialog1.Execute then
    begin
      Panel5.Color:=ColorDialog1.Color;
    end;
end;

procedure TIAChartBaseLinesEditWindow.Button3Click(Sender: TObject);
begin
  BackRefreshData;
  BackUpdate;
end;

procedure TIAChartBaseLinesEditWindow.Edit2Change(Sender: TObject);
begin
  (sender as TEdit).text:=inttostr(strtointdef((sender as TEdit).text,0));
  myarray.Lines[NLine].PointSize:=strtoint(Edit2.text);
end;

procedure TIAChartBaseLinesEditWindow.FormCreate(Sender: TObject);
begin
  myarray := IAChartBaseLineArray.Create(self);
  NLine:=-1;
end;

procedure TIAChartBaseLinesEditWindow.FormDestroy(Sender: TObject);
begin
  myarray.Free;
end;

procedure TIAChartBaseLinesEditWindow.GoDataFromArray;
var i : integer;
begin
  combobox1.Items.Clear;
  combobox1.Items.Add('None');
  combobox6.Items.Clear;
  combobox6.Items.Add('None');
  combobox7.Items.Clear;
  combobox7.Items.Add('None');
  combobox8.Items.Clear;
  combobox8.Items.Add('None');
  combobox9.Items.Clear;
  combobox9.Items.Add('None');
  combobox10.Items.Clear;
  combobox10.Items.Add('None');
  for i:=0 to myarray.LinesNumber-1 do
    begin
      combobox1.Items.Add('Line'+inttostr(i));
      combobox6.Items.Add('Line'+inttostr(i));
      combobox7.Items.Add('Line'+inttostr(i));
      combobox8.Items.Add('Line'+inttostr(i));
      combobox9.Items.Add('Line'+inttostr(i));
      combobox10.Items.Add('Line'+inttostr(i));
    end;
  Edit3.Text:=myarray.CommonInfo;
end;

procedure TIAChartBaseLinesEditWindow.Edit3Change(Sender: TObject);
begin
  myarray.CommonInfo:=Edit3.Text;
end;

procedure TIAChartBaseLinesEditWindow.ComboBox1Change(Sender: TObject);
var i : integer;
begin
//
  NLine:=-1;
  for i:=0 to Combobox1.Items.Count-1 do
    begin
      if Combobox1.Text=Combobox1.Items[i] then
        begin
          NLine:=i-1;
          break;
        end;
    end;
  if NLine>=0 then RefreshData(NLine);
end;

procedure TIAChartBaseLinesEditWindow.RefreshData(ANLine: integer);
begin
  Combobox6.ItemIndex:=myarray.Lines[ANLine].XaddLine+1;
  Combobox7.ItemIndex:=myarray.Lines[ANLine].XsubLine+1;
  Combobox8.ItemIndex:=myarray.Lines[ANLine].YaddLine+1;
  Combobox9.ItemIndex:=myarray.Lines[ANLine].YsubLine+1;
  Combobox10.ItemIndex:=myarray.Lines[ANLine].XLine+1;
  Edit2.text:=inttostr(myarray.Lines[ANLine].PointSize);
  Edit1.text:=myarray.Lines[ANLine].InfoString;
  panel6.color:=myarray.Lines[ANLine].LineColor;
  panel7.color:=myarray.Lines[ANLine].PointColor;
  panel8.color:=myarray.Lines[ANLine].DiapasonColor;

  Combobox2.ItemIndex:=ord(myarray.Lines[ANLine].LineType);
  Combobox3.ItemIndex:=ord(myarray.Lines[ANLine].LineStyle);
  Combobox4.ItemIndex:=ord(myarray.Lines[ANLine].PointType);
  Combobox5.ItemIndex:=ord(myarray.Lines[ANLine].DiapasonType);
end;

procedure TIAChartBaseLinesEditWindow.Button12Click(Sender: TObject);
begin
  ColorDialog1.Color:=Panel6.Color;
  if ColorDialog1.Execute then
    begin
      Panel6.Color:=ColorDialog1.Color;
      myarray.Lines[NLine].LineColor:=panel6.color;
    end;
end;

procedure TIAChartBaseLinesEditWindow.BackRefreshData;
begin
if NLine<0 then exit;
  myarray.Lines[NLine].XaddLine:=Combobox6.ItemIndex-1;
  myarray.Lines[NLine].XsubLine:=Combobox7.ItemIndex-1;
  myarray.Lines[NLine].YaddLine:=Combobox8.ItemIndex-1;
  myarray.Lines[NLine].YsubLine:=Combobox9.ItemIndex-1;
  myarray.Lines[NLine].XLine:=Combobox10.ItemIndex-1;
  myarray.Lines[NLine].PointSize:=strtoint(Edit2.text);
  myarray.Lines[NLine].InfoString:=Edit1.text;
  myarray.Lines[NLine].LineColor:=panel6.color;
  myarray.Lines[NLine].PointColor:=panel7.color;
  myarray.Lines[NLine].DiapasonColor:=panel8.color;
  myarray.Lines[NLine].LineType:=IAChartBaseLineType(Combobox2.ItemIndex);
  myarray.Lines[NLine].LineStyle:=IAChartBaseLineStyle(Combobox3.ItemIndex);
  myarray.Lines[NLine].PointType:=IAChartBaseLinePointType(Combobox4.ItemIndex);
  myarray.Lines[NLine].DiapasonType:=IAChartBaseLineDiapasonType(Combobox5.ItemIndex);
end;

procedure TIAChartBaseLinesEditWindow.Button11Click(Sender: TObject);
begin
  ColorDialog1.Color:=Panel7.Color;
  if ColorDialog1.Execute then
    begin
      Panel7.Color:=ColorDialog1.Color;
      myarray.Lines[NLine].PointColor:=panel7.color;
    end;
end;

procedure TIAChartBaseLinesEditWindow.Button13Click(Sender: TObject);
begin
  ColorDialog1.Color:=Panel8.Color;
  if ColorDialog1.Execute then
    begin
      Panel8.Color:=ColorDialog1.Color;
      myarray.Lines[NLine].DiapasonColor:=panel8.color;
    end;
end;

procedure TIAChartBaseLinesEditWindow.Edit1Change(Sender: TObject);
begin
  myarray.Lines[NLine].InfoString:=Edit1.text;
end;

procedure TIAChartBaseLinesEditWindow.ComboBox6Click(Sender: TObject);
begin
  myarray.Lines[NLine].XaddLine:=Combobox6.ItemIndex-1;
end;

procedure TIAChartBaseLinesEditWindow.ComboBox7Click(Sender: TObject);
begin
  myarray.Lines[NLine].XsubLine:=Combobox7.ItemIndex-1;
end;

procedure TIAChartBaseLinesEditWindow.ComboBox8Click(Sender: TObject);
begin
  myarray.Lines[NLine].YaddLine:=Combobox8.ItemIndex-1;
end;

procedure TIAChartBaseLinesEditWindow.ComboBox9Click(Sender: TObject);
begin
  myarray.Lines[NLine].YsubLine:=Combobox9.ItemIndex-1;
end;

procedure TIAChartBaseLinesEditWindow.ComboBox4Click(Sender: TObject);
begin
  myarray.Lines[NLine].PointType:=IAChartBaseLinePointType(Combobox4.ItemIndex);
end;

procedure TIAChartBaseLinesEditWindow.ComboBox5Click(Sender: TObject);
begin
  myarray.Lines[NLine].DiapasonType:=IAChartBaseLineDiapasonType(Combobox5.ItemIndex);
end;

procedure TIAChartBaseLinesEditWindow.ComboBox2Click(Sender: TObject);
begin
  myarray.Lines[NLine].LineType:=IAChartBaseLineType(Combobox2.ItemIndex);
end;

procedure TIAChartBaseLinesEditWindow.ComboBox3Click(Sender: TObject);
begin
  myarray.Lines[NLine].LineStyle:=IAChartBaseLineStyle(Combobox3.ItemIndex);
end;

procedure TIAChartBaseLinesEditWindow.ComboBox10Click(Sender: TObject);
begin
    myarray.Lines[NLine].XLine:=Combobox10.ItemIndex-1;
end;

end.
