unit IAUniChart2DEditorUnit;


interface
uses Windows, Messages,Controls,SysUtils, Classes,Graphics,dsgnintf;

type
TIAUniChart2DEditor = class(TComponentEditor)
public
  procedure Edit; override;

end;
implementation
uses IAUniChart2D,IAUniChart2DEditorWindow;

{ TIAUniChart2DEditor }

procedure TIAUniChart2DEditor.Edit;
begin
  IAUniChart2DEditorForm:=TIAUniChart2DEditorForm.Create(nil);
  if self.Component is TIAUniChart2D then
  IAUniChart2DEditorForm.IAUniChart2D1.assign(self.Component as TIAUniChart2D);
  IAUniChart2DEditorForm.ReCalibrate;
  IAUniChart2DEditorForm.ShowModal;
  case IAUniChart2DEditorForm.ModalResult of
    mrNone,mrCancel :
      begin
        IAUniChart2DEditorForm.Release;
      end;
    mrOk   :
      begin
        (self.Component as TIAUniChart2D).assign(IAUniChart2DEditorForm.IAUniChart2D1);
        IAUniChart2DEditorForm.Release;
        designer.Modified;
      end;
    else
      begin
        IAUniChart2DEditorForm.Release;
        designer.Modified;
      end;  
  end;
end;

end.
