unit IAUniChart2DEditorWindow;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, ExtCtrls, IAUniChart2D, StdCtrls, Buttons,IAChartBaseTextUnit,IAChartBaseAxisUnit;

type
  TIAUniChart2DEditorForm = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    Panel2: TPanel;
    Panel4: TPanel;
    Button1: TButton;
    Button2: TButton;
    GroupBox1: TGroupBox;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    CheckBox7: TCheckBox;
    CheckBox8: TCheckBox;
    CheckBox9: TCheckBox;
    Panel1: TPanel;
    ScrollBar1: TScrollBar;
    ScrollBar2: TScrollBar;
    Panel3: TPanel;
    IAUniChart2D1: TIAUniChart2D;
    Label1: TLabel;
    GroupBox2: TGroupBox;
    CheckBox10: TCheckBox;
    CheckBox11: TCheckBox;
    CheckBox12: TCheckBox;
    CheckBox13: TCheckBox;
    CheckBox14: TCheckBox;
    CheckBox15: TCheckBox;
    CheckBox16: TCheckBox;
    CheckBox17: TCheckBox;
    CheckBox18: TCheckBox;
    Panel6: TPanel;
    Image1: TImage;
    Panel5: TPanel;
    GroupBox3: TGroupBox;
    CheckBox19: TCheckBox;
    CheckBox20: TCheckBox;
    CheckBox21: TCheckBox;
    CheckBox22: TCheckBox;
    CheckBox23: TCheckBox;
    CheckBox24: TCheckBox;
    CheckBox25: TCheckBox;
    CheckBox26: TCheckBox;
    CheckBox27: TCheckBox;
    CheckBox28: TCheckBox;
    CheckBox29: TCheckBox;
    CheckBox30: TCheckBox;
    CheckBox31: TCheckBox;
    CheckBox32: TCheckBox;
    Panel7: TPanel;
    Image2: TImage;
    Panel8: TPanel;
    GroupBox4: TGroupBox;
    CheckBox33: TCheckBox;
    CheckBox34: TCheckBox;
    CheckBox35: TCheckBox;
    CheckBox36: TCheckBox;
    CheckBox37: TCheckBox;
    CheckBox38: TCheckBox;
    CheckBox39: TCheckBox;
    GroupBox5: TGroupBox;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    Label2: TLabel;
    Edit1: TEdit;
    BitBtn5: TBitBtn;
    BitBtn6: TBitBtn;
    BitBtn7: TBitBtn;
    CheckBox40: TCheckBox;
    Panel9: TPanel;
    RadioGroup1: TRadioGroup;
    Memo1: TMemo;
    Label3: TLabel;
    FontDialog1: TFontDialog;
    Button3: TButton;
    Memo2: TMemo;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    procedure ScrollBar1Scroll(Sender: TObject; ScrollCode: TScrollCode;
      var ScrollPos: Integer);
    procedure ScrollBar2Scroll(Sender: TObject; ScrollCode: TScrollCode;
      var ScrollPos: Integer);
    procedure Panel1Resize(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure CheckBox6Click(Sender: TObject);
    procedure CheckBox5Click(Sender: TObject);
    procedure CheckBox4Click(Sender: TObject);
    procedure CheckBox9Click(Sender: TObject);
    procedure CheckBox8Click(Sender: TObject);
    procedure CheckBox7Click(Sender: TObject);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure Image2MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Image2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure CheckBox33Click(Sender: TObject);
    procedure CheckBox34Click(Sender: TObject);
    procedure CheckBox35Click(Sender: TObject);
    procedure CheckBox36Click(Sender: TObject);
    procedure CheckBox37Click(Sender: TObject);
    procedure CheckBox38Click(Sender: TObject);
    procedure CheckBox39Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure BitBtn5Click(Sender: TObject);
    procedure BitBtn6Click(Sender: TObject);
    procedure BitBtn7Click(Sender: TObject);
    procedure CheckBox40Click(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
    procedure Memo1Change(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Memo1Exit(Sender: TObject);
  private
    Ar,Ag,Ab : Byte;
    AStart,ALength : integer;
    { Private declarations }
  public
    procedure ReCalibrate;
    { Public declarations }
  end;

var
  IAUniChart2DEditorForm: TIAUniChart2DEditorForm;

implementation

{$R *.DFM}

{ TIAUniChart2DEditorForm }

procedure TIAUniChart2DEditorForm.ReCalibrate;
begin
  if Panel3.ClientWidth>(IAUniChart2D1.Width) then
    begin
      ScrollBar1.Hide;
    end else
    begin
      ScrollBar1.Max:=-(Panel3.ClientWidth-(IAUniChart2D1.Width));
      ScrollBar1.show;
    end;
  if Panel3.ClientHeight>(IAUniChart2D1.Height) then
    begin
      ScrollBar2.Hide;
    end else
    begin
      ScrollBar2.Max:=-(Panel3.ClientHeight-(IAUniChart2D1.Height));
      ScrollBar2.show;
    end;
  CheckBox1.Checked:=IAUniChart2D1.MainCaption.Visible;
  CheckBox2.Checked:=IAUniChart2D1.XCaption.Visible;
  CheckBox3.Checked:=IAUniChart2D1.YCaption.Visible;
  CheckBox6.Checked:=IAUniChart2D1.YCaption2.Visible;

  CheckBox5.Checked:=IAUniChart2D1.LinesField.Visible;
  CheckBox4.Checked:=IAUniChart2D1.UserTextField.Visible;
  CheckBox9.Checked:=IAUniChart2D1.XAxis.Visible;
  CheckBox8.Checked:=IAUniChart2D1.YAxis.Visible;
  CheckBox7.Checked:=IAUniChart2D1.YAxis2.Visible;

  CheckBox33.Checked:=IAUniChart2D1.MainCaption.Transparent;
  CheckBox34.Checked:=IAUniChart2D1.XCaption.Transparent;
  CheckBox35.Checked:=IAUniChart2D1.YCaption.Transparent;
  CheckBox36.Checked:=IAUniChart2D1.YCaption2.Transparent;

  CheckBox37.Checked:=IAUniChart2D1.LinesField.Transparent;
  CheckBox38.Checked:=IAUniChart2D1.UserTextField.Transparent;
  CheckBox39.Checked:=IAUniChart2D1.MainField.Transparent;
  CheckBox40.Checked:=IAUniChart2D1.MainField.ShowGrid;
end;

procedure TIAUniChart2DEditorForm.ScrollBar1Scroll(Sender: TObject;
  ScrollCode: TScrollCode; var ScrollPos: Integer);
begin
  //
  IAUniChart2D1.left:=-ScrollPos;
end;

procedure TIAUniChart2DEditorForm.ScrollBar2Scroll(Sender: TObject;
  ScrollCode: TScrollCode; var ScrollPos: Integer);
begin
  IAUniChart2D1.top:=-ScrollPos;
end;

procedure TIAUniChart2DEditorForm.Panel1Resize(Sender: TObject);
begin
  ReCalibrate;
end;

procedure TIAUniChart2DEditorForm.CheckBox1Click(Sender: TObject);
begin
  IAUniChart2D1.MainCaption.Visible:=CheckBox1.Checked;
end;

procedure TIAUniChart2DEditorForm.CheckBox2Click(Sender: TObject);
begin
  IAUniChart2D1.XCaption.Visible:=CheckBox2.Checked;
end;

procedure TIAUniChart2DEditorForm.CheckBox3Click(Sender: TObject);
begin
  IAUniChart2D1.YCaption.Visible:=CheckBox3.Checked;
end;

procedure TIAUniChart2DEditorForm.CheckBox6Click(Sender: TObject);
begin
  IAUniChart2D1.YCaption2.Visible:=CheckBox6.Checked;
end;

procedure TIAUniChart2DEditorForm.CheckBox5Click(Sender: TObject);
begin
  IAUniChart2D1.LinesField.Visible:=CheckBox5.Checked;
end;

procedure TIAUniChart2DEditorForm.CheckBox4Click(Sender: TObject);
begin
  IAUniChart2D1.UserTextField.Visible:=CheckBox4.Checked;
end;

procedure TIAUniChart2DEditorForm.CheckBox9Click(Sender: TObject);
begin
  IAUniChart2D1.XAxis.Visible:=CheckBox9.Checked;
end;

procedure TIAUniChart2DEditorForm.CheckBox8Click(Sender: TObject);
begin
  IAUniChart2D1.YAxis.Visible:=CheckBox8.Checked;
end;

procedure TIAUniChart2DEditorForm.CheckBox7Click(Sender: TObject);
begin
  IAUniChart2D1.YAxis2.Visible:=CheckBox7.Checked;
end;

procedure TIAUniChart2DEditorForm.Image1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var i : integer;
    r1,g1,b1,r2,g2,b2 : integer;
begin
//
  r1:=GetRValue(Image1.Picture.Bitmap.canvas.pixels[x,y]);
  g1:=GetGValue(Image1.Picture.Bitmap.canvas.pixels[x,y]);
  b1:=GetBValue(Image1.Picture.Bitmap.canvas.pixels[x,y]);

  for i:=-255 to 255 do
    begin
      if i>0 then
        begin
          if (i+r1)>255 then r2:=255 else r2:=(i+r1);
          if (i+g1)>255 then g2:=255 else g2:=(i+g1);
          if (i+b1)>255 then b2:=255 else b2:=(i+b1);
          Image2.Picture.Bitmap.Canvas.pen.Color:=rgb(r2,g2,b2);
          Image2.Picture.Bitmap.Canvas.moveto(0,Image2.Picture.Bitmap.Height-1-(i+255)*Image2.Picture.Bitmap.Height div 510);
          Image2.Picture.Bitmap.Canvas.lineto(Image2.Picture.Bitmap.width-1,
          Image2.Picture.Bitmap.Height-1-(i+255)*Image2.Picture.Bitmap.Height div 510);
        end else
        begin
          if (i+r1)<0 then r2:=0 else r2:=(i+r1);
          if (i+g1)<0 then g2:=0 else g2:=(i+g1);
          if (i+b1)<0 then b2:=0 else b2:=(i+b1);
          Image2.Picture.Bitmap.Canvas.pen.Color:=rgb(r2,g2,b2);
          Image2.Picture.Bitmap.Canvas.moveto(0,Image2.Picture.Bitmap.Height-1-(i+255)*Image2.Picture.Bitmap.Height div 510);
          Image2.Picture.Bitmap.Canvas.lineto(Image2.Picture.Bitmap.width-1,
          Image2.Picture.Bitmap.Height-1-(i+255)*Image2.Picture.Bitmap.Height div 510);
        end;
    end;
end;

procedure TIAUniChart2DEditorForm.FormCreate(Sender: TObject);
begin
  Ar:=0;
  Ag:=0;
  Ab:=0;
  Memo2.Lines.Add('Tags - short info');
  Memo2.Lines.Add('<B></B> - Bold font');
  Memo2.Lines.Add('<I></I> - Italic Font');
  Memo2.Lines.Add('<U></U> - Underline Font');
  Memo2.Lines.Add('<up></up> - Up index');
  Memo2.Lines.Add('<down></down> - Down Index');
  Memo2.Lines.Add('<size>8</size>- font is size 8');
  Memo2.Lines.Add('<inline>0</inline> - insert picture from imagelist at index 0');

end;

procedure TIAUniChart2DEditorForm.Image2MouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  Ar:=GetRValue(Image2.Picture.Bitmap.canvas.pixels[x,y]);
  Ag:=GetGValue(Image2.Picture.Bitmap.canvas.pixels[x,y]);
  Ab:=GetBValue(Image2.Picture.Bitmap.canvas.pixels[x,y]);
  Panel5.Color:=RGB(Ar,Ag,Ab);
end;

procedure TIAUniChart2DEditorForm.Image2MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  Ar:=GetRValue(Image2.Picture.Bitmap.canvas.pixels[x,y]);
  Ag:=GetGValue(Image2.Picture.Bitmap.canvas.pixels[x,y]);
  Ab:=GetBValue(Image2.Picture.Bitmap.canvas.pixels[x,y]);
  Panel5.Color:=RGB(Ar,Ag,Ab);
  case PageControl1.ActivePage.TabIndex of
    0 :
      begin
        if CheckBox10.Checked then
          begin
            IAUniChart2D1.MainCaption.color:=Panel5.Color;
          end;
        if CheckBox11.Checked then
          begin
            IAUniChart2D1.XCaption.color:=Panel5.Color;
          end;
        if CheckBox12.Checked then
          begin
            IAUniChart2D1.YCaption.color:=Panel5.Color;
          end;
        if CheckBox13.Checked then
          begin
            IAUniChart2D1.YCaption2.color:=Panel5.Color;
          end;
        if CheckBox14.Checked then
          begin
            IAUniChart2D1.LinesField.color:=Panel5.Color;
          end;
        if CheckBox15.Checked then
          begin
            IAUniChart2D1.UserTextField.color:=Panel5.Color;
          end;
        if CheckBox16.Checked then
          begin
            IAUniChart2D1.XAxis.color:=Panel5.Color;
          end;
        if CheckBox17.Checked then
          begin
            IAUniChart2D1.YAxis.color:=Panel5.Color;
          end;
        if CheckBox18.Checked then
          begin
            IAUniChart2D1.YAxis2.color:=Panel5.Color;
          end;      
        if CheckBox19.Checked then
          begin
            IAUniChart2D1.MainCaption.Font.Color:=Panel5.Color;
          end;
        if CheckBox20.Checked then
          begin
            IAUniChart2D1.XCaption.Font.color:=Panel5.Color;
          end;
        if CheckBox21.Checked then
          begin
            IAUniChart2D1.YCaption.Font.color:=Panel5.Color;
          end;
        if CheckBox22.Checked then
          begin
            IAUniChart2D1.YCaption2.Font.color:=Panel5.Color;
          end;
        if CheckBox23.Checked then
          begin
            IAUniChart2D1.LinesField.Font.color:=Panel5.Color;
          end;
        if CheckBox24.Checked then
          begin
            IAUniChart2D1.UserTextField.Font.color:=Panel5.Color;
          end;
        if CheckBox25.Checked then
          begin
            IAUniChart2D1.XAxis.font.color:=Panel5.Color;
          end;
        if CheckBox26.Checked then
          begin
            IAUniChart2D1.bevelcolor:=Panel5.Color;
          end;
        if CheckBox27.Checked then
          begin
            IAUniChart2D1.color:=Panel5.Color;
          end;
        if CheckBox28.Checked then
          begin
            IAUniChart2D1.mainfield.color:=Panel5.Color;
          end;
        if CheckBox29.Checked then
          begin
            IAUniChart2D1.mainfield.colorgridX:=Panel5.Color;
          end;
        if CheckBox30.Checked then
          begin
            IAUniChart2D1.mainfield.colorgridY:=Panel5.Color;
          end;
        if CheckBox31.Checked then
          begin
            IAUniChart2D1.mainfield.colorgridY2:=Panel5.Color;
          end;
        if CheckBox32.Checked then
          begin
            IAUniChart2D1.mainfield.colorgridBorder:=Panel5.Color;
          end;


     end;//0
  end;//case

end;

procedure TIAUniChart2DEditorForm.CheckBox33Click(Sender: TObject);
begin
  IAUniChart2D1.MainCaption.Transparent:=CheckBox33.Checked;
end;

procedure TIAUniChart2DEditorForm.CheckBox34Click(Sender: TObject);
begin
  IAUniChart2D1.XCaption.Transparent:=CheckBox34.Checked;
end;

procedure TIAUniChart2DEditorForm.CheckBox35Click(Sender: TObject);
begin
  IAUniChart2D1.YCaption.Transparent:=CheckBox35.Checked;
end;

procedure TIAUniChart2DEditorForm.CheckBox36Click(Sender: TObject);
begin
  IAUniChart2D1.YCaption2.Transparent:=CheckBox36.Checked;
end;

procedure TIAUniChart2DEditorForm.CheckBox37Click(Sender: TObject);
begin
  IAUniChart2D1.LinesField.Transparent:=CheckBox37.Checked;
end;

procedure TIAUniChart2DEditorForm.CheckBox38Click(Sender: TObject);
begin
  IAUniChart2D1.UserTextField.Transparent:=CheckBox38.Checked;
end;

procedure TIAUniChart2DEditorForm.CheckBox39Click(Sender: TObject);
begin
  IAUniChart2D1.MainField.Transparent:=CheckBox39.Checked;
end;

procedure TIAUniChart2DEditorForm.BitBtn1Click(Sender: TObject);
var dy,dx,dg : integer;
begin
  dg:=strtointdef(Edit1.text,8);
  Edit1.text:=inttostr(dg);

  IAUniChart2D1.MainCaption.TextOrientation:=iacbto_0_Degrees;

  IAUniChart2D1.YAxis2.Visible:=false;
  IAUniChart2D1.YCaption2.Visible:=false;

  IAUniChart2D1.YAxis.Visible:=True;
  IAUniChart2D1.YCaption.Visible:=True;
  IAUniChart2D1.YCaption.TextOrientation:=iacbto_90_Degrees;

  IAUniChart2D1.XAxis.Visible:=True;
  IAUniChart2D1.XAxis.AxisType:=iacbatHorizontal;
  IAUniChart2D1.XCaption.Visible:=True;
  IAUniChart2D1.XCaption.TextOrientation:=iacbto_0_Degrees;

  application.ProcessMessages;

  dy:=IAUniChart2D1.XCaption.Height+IAUniChart2D1.XAxis.Height div 2;
  dx:=IAUniChart2D1.YCaption.Width+IAUniChart2D1.YAxis.Width div 2;

  IAUniChart2D1.XAxis.CenterPointLeft:=dx+dg;
  IAUniChart2D1.XAxis.CenterPointTop:=IAUniChart2D1.GetInnerHeight-dy-dg;
  IAUniChart2D1.YAxis.CenterPointLeft:=dx+dg;
  IAUniChart2D1.YAxis.CenterPointTop:=IAUniChart2D1.GetInnerHeight-dy-dg;

  IAUniChart2D1.XAxis.SetLength(IAUniChart2D1.GetInnerWidth - dx-3*dg);
  IAUniChart2D1.YAxis.SetLength(IAUniChart2D1.GetInnerHeight - dy-3*dg);

  IAUniChart2D1.Reasseble;
  ReCalibrate;

end;

procedure TIAUniChart2DEditorForm.BitBtn2Click(Sender: TObject);
var dy,dx,dg : integer;
begin
  dg:=strtointdef(Edit1.text,8);
  Edit1.text:=inttostr(dg);

  IAUniChart2D1.MainCaption.TextOrientation:=iacbto_0_Degrees;

  IAUniChart2D1.YAxis2.Visible:=false;
  IAUniChart2D1.YCaption2.Visible:=false;

  IAUniChart2D1.YAxis.Visible:=True;
  IAUniChart2D1.YCaption.Visible:=True;
  IAUniChart2D1.YCaption.TextOrientation:=iacbto_90_Degrees;

  IAUniChart2D1.XAxis.Visible:=True;
  IAUniChart2D1.XAxis.AxisType:=iacbatHorizontal;
  IAUniChart2D1.XCaption.Visible:=True;
  IAUniChart2D1.XCaption.TextOrientation:=iacbto_0_Degrees;

    application.ProcessMessages;

  dy:=IAUniChart2D1.XCaption.Height+IAUniChart2D1.XAxis.Height div 2;
  dx:=IAUniChart2D1.YCaption.Width+IAUniChart2D1.YAxis.Width div 2;

  IAUniChart2D1.XAxis.CenterPointLeft:=dx+dg;
  IAUniChart2D1.XAxis.CenterPointTop:=dy+dg;
  IAUniChart2D1.YAxis.CenterPointLeft:=dx+dg;
  IAUniChart2D1.YAxis.CenterPointTop:=IAUniChart2D1.GetInnerHeight-2*dg;

  IAUniChart2D1.XAxis.SetLength(IAUniChart2D1.GetInnerWidth - dx-3*dg);
  IAUniChart2D1.YAxis.SetLength(IAUniChart2D1.GetInnerHeight - dy-3*dg);

  IAUniChart2D1.Reasseble;
  ReCalibrate;

end;

procedure TIAUniChart2DEditorForm.BitBtn3Click(Sender: TObject);
var dy,dx,dg : integer;
begin
  dg:=strtointdef(Edit1.text,8);
  Edit1.text:=inttostr(dg);

  IAUniChart2D1.MainCaption.TextOrientation:=iacbto_90_Degrees;

  IAUniChart2D1.YAxis2.Visible:=false;
  IAUniChart2D1.YCaption2.Visible:=false;

  IAUniChart2D1.XAxis.Visible:=True;
  IAUniChart2D1.XAxis.AxisType:=iacbatVertical;
  IAUniChart2D1.XCaption.Visible:=True;
  IAUniChart2D1.XCaption.TextOrientation:=iacbto_90_Degrees;

  IAUniChart2D1.YAxis.Visible:=True;
  IAUniChart2D1.YCaption.Visible:=True;
  IAUniChart2D1.YCaption.TextOrientation:=iacbto_0_Degrees;

    application.ProcessMessages;

  dy:=IAUniChart2D1.YCaption.Height+IAUniChart2D1.YAxis.Height div 2;
  dx:=IAUniChart2D1.XCaption.Width+IAUniChart2D1.XAxis.Width div 2;

  IAUniChart2D1.YAxis.CenterPointLeft:=dx+dg;
  IAUniChart2D1.YAxis.CenterPointTop:=IAUniChart2D1.GetInnerHeight-dy-dg;
  IAUniChart2D1.XAxis.CenterPointLeft:=dx+dg;
  IAUniChart2D1.XAxis.CenterPointTop:=IAUniChart2D1.GetInnerHeight-dy-dg;

  IAUniChart2D1.YAxis.SetLength(IAUniChart2D1.GetInnerWidth - dx-3*dg);
  IAUniChart2D1.XAxis.SetLength(IAUniChart2D1.GetInnerHeight - dy-3*dg);

  IAUniChart2D1.Reasseble;
  ReCalibrate;

end;

procedure TIAUniChart2DEditorForm.BitBtn4Click(Sender: TObject);
var dy,dx,dg : integer;
begin
  dg:=strtointdef(Edit1.text,8);
  Edit1.text:=inttostr(dg);

  IAUniChart2D1.MainCaption.TextOrientation:=iacbto_0_Degrees;

  IAUniChart2D1.YAxis2.Visible:=false;
  IAUniChart2D1.YCaption2.Visible:=false;

  IAUniChart2D1.YAxis.Visible:=True;
  IAUniChart2D1.YCaption.Visible:=True;
  IAUniChart2D1.YCaption.TextOrientation:=iacbto_90_Degrees;

  IAUniChart2D1.XAxis.Visible:=True;
  IAUniChart2D1.XAxis.AxisType:=iacbatHorizontal;
  IAUniChart2D1.XCaption.Visible:=True;
  IAUniChart2D1.XCaption.TextOrientation:=iacbto_0_Degrees;

    application.ProcessMessages;

  dy:=IAUniChart2D1.XCaption.Height+IAUniChart2D1.XAxis.Height div 2;
  dx:=IAUniChart2D1.YCaption.Width+IAUniChart2D1.YAxis.Width div 2;

  IAUniChart2D1.XAxis.CenterPointLeft:=2*dg;
  IAUniChart2D1.XAxis.CenterPointTop:=IAUniChart2D1.GetInnerHeight-dy-dg;
  IAUniChart2D1.YAxis.CenterPointLeft:=IAUniChart2D1.GetInnerWidth-dx-dg;
  IAUniChart2D1.YAxis.CenterPointTop:=IAUniChart2D1.GetInnerHeight-dy-dg;

  IAUniChart2D1.XAxis.SetLength(IAUniChart2D1.GetInnerWidth - dx-3*dg);
  IAUniChart2D1.YAxis.SetLength(IAUniChart2D1.GetInnerHeight - dy-3*dg);

  IAUniChart2D1.Reasseble;
  ReCalibrate;

end;


procedure TIAUniChart2DEditorForm.BitBtn5Click(Sender: TObject);
var dy,dx,dg,dx2 : integer;
begin
  dg:=strtointdef(Edit1.text,8);
  Edit1.text:=inttostr(dg);

  IAUniChart2D1.MainCaption.TextOrientation:=iacbto_0_Degrees;

  IAUniChart2D1.YAxis2.Visible:=True;
  IAUniChart2D1.YCaption2.Visible:=True;
  IAUniChart2D1.YCaption2.TextOrientation:=iacbto_90_Degrees;

  IAUniChart2D1.YAxis.Visible:=True;
  IAUniChart2D1.YCaption.Visible:=True;
  IAUniChart2D1.YCaption.TextOrientation:=iacbto_90_Degrees;

  IAUniChart2D1.XAxis.Visible:=True;
  IAUniChart2D1.XAxis.AxisType:=iacbatHorizontal;
  IAUniChart2D1.XCaption.Visible:=True;
  IAUniChart2D1.XCaption.TextOrientation:=iacbto_0_Degrees;

  application.ProcessMessages;

  dy:=IAUniChart2D1.XCaption.Height+IAUniChart2D1.XAxis.Height div 2;
  dx:=IAUniChart2D1.YCaption.Width+IAUniChart2D1.YAxis.Width div 2;
  dx2:=IAUniChart2D1.YCaption2.Width+IAUniChart2D1.YAxis2.Width div 2;

  IAUniChart2D1.XAxis.CenterPointLeft:=dx+dg;
  IAUniChart2D1.XAxis.CenterPointTop:=IAUniChart2D1.GetInnerHeight-dy-dg;
  IAUniChart2D1.YAxis.CenterPointLeft:=dx+dg;
  IAUniChart2D1.YAxis.CenterPointTop:=IAUniChart2D1.GetInnerHeight-dy-dg;
  IAUniChart2D1.YAxis2.CenterPointLeft:=IAUniChart2D1.GetInnerWidth-dx2-dg;
  IAUniChart2D1.YAxis2.CenterPointTop:=IAUniChart2D1.GetInnerHeight-dy-dg;

  IAUniChart2D1.XAxis.SetLength(IAUniChart2D1.GetInnerWidth - dx-2*dg-dx2);
  IAUniChart2D1.YAxis.SetLength(IAUniChart2D1.GetInnerHeight - dy-3*dg);
  IAUniChart2D1.YAxis2.SetLength(IAUniChart2D1.GetInnerHeight - dy-3*dg);

  IAUniChart2D1.Reasseble;
  ReCalibrate;

end;

procedure TIAUniChart2DEditorForm.BitBtn6Click(Sender: TObject);
var dy,dx,dg,dx2 : integer;
begin
  dg:=strtointdef(Edit1.text,8);
  Edit1.text:=inttostr(dg);

  IAUniChart2D1.MainCaption.TextOrientation:=iacbto_0_Degrees;

  IAUniChart2D1.YAxis2.Visible:=True;
  IAUniChart2D1.YCaption2.Visible:=True;
  IAUniChart2D1.YCaption2.TextOrientation:=iacbto_90_Degrees;

  IAUniChart2D1.YAxis.Visible:=True;
  IAUniChart2D1.YCaption.Visible:=false;
  IAUniChart2D1.YCaption.TextOrientation:=iacbto_90_Degrees;

  IAUniChart2D1.XAxis.Visible:=True;
  IAUniChart2D1.XAxis.AxisType:=iacbatHorizontal;
  IAUniChart2D1.XCaption.Visible:=True;
  IAUniChart2D1.XCaption.TextOrientation:=iacbto_0_Degrees;

  application.ProcessMessages;

  dy:=IAUniChart2D1.XCaption.Height+IAUniChart2D1.XAxis.Height div 2;
  dx:=IAUniChart2D1.YAxis2.Width div 2+IAUniChart2D1.YAxis.Width div 2;
  dx2:=IAUniChart2D1.YCaption2.Width+IAUniChart2D1.YAxis2.Width div 2;

  IAUniChart2D1.XAxis.CenterPointLeft:=dx+dx2+dg;
  IAUniChart2D1.XAxis.CenterPointTop:=IAUniChart2D1.GetInnerHeight-dy-dg;
  IAUniChart2D1.YAxis.CenterPointLeft:=dx+dx2+dg;
  IAUniChart2D1.YAxis.CenterPointTop:=IAUniChart2D1.GetInnerHeight-dy-dg;
  IAUniChart2D1.YAxis2.CenterPointLeft:=dx2+dg;
  IAUniChart2D1.YAxis2.CenterPointTop:=IAUniChart2D1.GetInnerHeight-dy-dg;

  IAUniChart2D1.XAxis.SetLength(IAUniChart2D1.GetInnerWidth - dx-3*dg-dx2);
  IAUniChart2D1.YAxis.SetLength(IAUniChart2D1.GetInnerHeight - dy-3*dg);
  IAUniChart2D1.YAxis2.SetLength(IAUniChart2D1.GetInnerHeight - dy-3*dg);

  IAUniChart2D1.Reasseble;
  ReCalibrate;

end;

procedure TIAUniChart2DEditorForm.BitBtn7Click(Sender: TObject);
var dy,dx,dg,dy2 : integer;
begin
  dg:=strtointdef(Edit1.text,8);
  Edit1.text:=inttostr(dg);

  IAUniChart2D1.MainCaption.TextOrientation:=iacbto_270_Degrees;

  IAUniChart2D1.YAxis2.Visible:=True;
  IAUniChart2D1.YCaption2.Visible:=True;
  IAUniChart2D1.YCaption2.TextOrientation:=iacbto_0_Degrees;

  IAUniChart2D1.YAxis.Visible:=True;
  IAUniChart2D1.YCaption.Visible:=True;
  IAUniChart2D1.YCaption.TextOrientation:=iacbto_0_Degrees;

  IAUniChart2D1.XAxis.Visible:=True;
  IAUniChart2D1.XAxis.AxisType:=iacbatVertical;
  IAUniChart2D1.XCaption.Visible:=True;
  IAUniChart2D1.XCaption.TextOrientation:=iacbto_90_Degrees;

  application.ProcessMessages;

  dy:=IAUniChart2D1.YCaption.Height+IAUniChart2D1.YAxis.Height div 2;
  dx:=IAUniChart2D1.XCaption.Width+IAUniChart2D1.XAxis.Width div 2;
  dy2:=IAUniChart2D1.YCaption2.Height+IAUniChart2D1.YAxis2.Height div 2;

  IAUniChart2D1.XAxis.CenterPointLeft:=dx+dg;
  IAUniChart2D1.XAxis.CenterPointTop:=IAUniChart2D1.GetInnerHeight-dy-dg;
  IAUniChart2D1.YAxis.CenterPointLeft:=dx+dg;
  IAUniChart2D1.YAxis.CenterPointTop:=IAUniChart2D1.GetInnerHeight-dy-dg;
  IAUniChart2D1.YAxis2.CenterPointLeft:=dx+dg;
  IAUniChart2D1.YAxis2.CenterPointTop:=dy2+dg;

  IAUniChart2D1.XAxis.SetLength(IAUniChart2D1.GetInnerHeight - dy-dy2-2*dg);
  IAUniChart2D1.YAxis.SetLength(IAUniChart2D1.GetInnerWidth - dx-3*dg);
  IAUniChart2D1.YAxis2.SetLength(IAUniChart2D1.GetInnerWidth - dx-3*dg);

  IAUniChart2D1.Reasseble;
  ReCalibrate;

end;

procedure TIAUniChart2DEditorForm.CheckBox40Click(Sender: TObject);
begin
  IAUniChart2D1.MainField.ShowGrid:=CheckBox40.Checked;
end;

procedure TIAUniChart2DEditorForm.RadioGroup1Click(Sender: TObject);
begin
  case RadioGroup1.ItemIndex of
    0 :
      begin
        Memo1.Lines.Text:=IAUniChart2D1.MainCaption.Text;
        FontDialog1.Font:=IAUniChart2D1.MainCaption.Font;
      end;
    1 :
      begin
        Memo1.Lines.Text:=IAUniChart2D1.XCaption.Text;
        FontDialog1.Font:=IAUniChart2D1.XCaption.Font;
      end;
    2 :
      begin
        Memo1.Lines.Text:=IAUniChart2D1.YCaption.Text;
        FontDialog1.Font:=IAUniChart2D1.YCaption.Font;
      end;
    3 :
      begin
        Memo1.Lines.Text:=IAUniChart2D1.YCaption2.Text;
        FontDialog1.Font:=IAUniChart2D1.YCaption2.Font;
      end;
    4 :
      begin
        Memo1.Lines.Text:=IAUniChart2D1.UserTextField.StringsArray.Text;
        FontDialog1.Font:=IAUniChart2D1.UserTextField.Font;
      end;
  end;
end;

procedure TIAUniChart2DEditorForm.Memo1Change(Sender: TObject);
begin
   case RadioGroup1.ItemIndex of
    0 :
      begin
        if IAUniChart2D1.MainCaption.Text<>Memo1.Lines.Text then
        IAUniChart2D1.MainCaption.Text:=Memo1.Lines.Text;

      end;
    1 :
      begin
        if IAUniChart2D1.XCaption.Text<>Memo1.Lines.Text then
        IAUniChart2D1.XCaption.Text:=Memo1.Lines.Text;
      end;
    2 :
      begin
        if IAUniChart2D1.YCaption.Text<>Memo1.Lines.Text then
        IAUniChart2D1.YCaption.Text:=Memo1.Lines.Text;
      end;
    3 :
      begin
        if IAUniChart2D1.YCaption2.Text<>Memo1.Lines.Text then
        IAUniChart2D1.YCaption2.Text:=Memo1.Lines.Text;
      end;
    4 :
      begin
        if IAUniChart2D1.UserTextField.Text<>Memo1.Lines.Text then
        IAUniChart2D1.UserTextField.Text:=Memo1.Lines.Text;
      end;
  end;
end;

procedure TIAUniChart2DEditorForm.Button3Click(Sender: TObject);
begin
  if FontDialog1.Execute then
    begin
      case RadioGroup1.ItemIndex of
        0 :
          begin
            IAUniChart2D1.MainCaption.font:=FontDialog1.Font;

          end;
        1 :
          begin
            IAUniChart2D1.XCaption.font:=FontDialog1.Font;
          end;
        2 :
          begin
            IAUniChart2D1.YCaption.font:=FontDialog1.Font;
          end;
        3 :
          begin
            IAUniChart2D1.YCaption2.font:=FontDialog1.Font;
          end;
        4 :
          begin
            IAUniChart2D1.UserTextField.font:=FontDialog1.Font;
          end;
      end;
    end;
end;

procedure TIAUniChart2DEditorForm.Button4Click(Sender: TObject);
var s : string;
begin
  s:=copy(memo1.Lines.Text,0,aStart)+'<up>'+copy(memo1.Lines.Text,aStart+1,aLength)+'</up>'+
  copy(memo1.Lines.Text,aStart+aLength+1,length(memo1.Lines.Text)-aStart-aLength);
  memo1.Lines.Text:=s;
end;

procedure TIAUniChart2DEditorForm.Button5Click(Sender: TObject);
var s : string;
begin
  s:=copy(memo1.Lines.Text,0,aStart)+'<down>'+copy(memo1.Lines.Text,aStart+1,aLength)+'</down>'+
  copy(memo1.Lines.Text,aStart+aLength+1,length(memo1.Lines.Text)-aStart-aLength);
  memo1.Lines.Text:=s;
end;

procedure TIAUniChart2DEditorForm.Button6Click(Sender: TObject);
var s : string;
begin
  s:=copy(memo1.Lines.Text,0,aStart)+'<size>'+'8</size>'+copy(memo1.Lines.Text,aStart+1,aLength)+
  copy(memo1.Lines.Text,aStart+aLength+1,length(memo1.Lines.Text)-aStart-aLength);
  memo1.Lines.Text:=s;
end;

procedure TIAUniChart2DEditorForm.Button7Click(Sender: TObject);
var s : string;
begin
  s:=copy(memo1.Lines.Text,0,aStart)+'<inline>'+'8</inline>'+copy(memo1.Lines.Text,aStart+1,aLength)+
  copy(memo1.Lines.Text,aStart+aLength+1,length(memo1.Lines.Text)-aStart-aLength);
  memo1.Lines.Text:=s;
end;

procedure TIAUniChart2DEditorForm.Memo1Exit(Sender: TObject);
begin
//
AStart:=memo1.SelStart;
Alength:=memo1.SelLength;
end;

end.
